﻿Public Class Filter

    Private AmpFactorInc As Double
    Private AmpFactorDec As Double
    Private LinFactorInc As Double
    Private LinFactorDec As Double
    Private OutValue As Double
    Friend LinearMode As Boolean = True

    Public Sub New(ByVal SamplingTimeMS As Double, _
                   ByVal TimeConstInc_Sec As Double, _
                   ByVal TimeConstDec_Sec As Double)

        OutValue = 0

        Dim FreqInc As Double
        Dim FreqDec As Double
        Dim tauMSInc As Double
        Dim tauMSDec As Double
        Dim tauSampsInc As Double
        Dim tauSampsDec As Double

        FreqInc = 1 / (2 * Math.PI * TimeConstInc_Sec)
        tauMSInc = 1000 / (2 * Math.PI * FreqInc)
        tauSampsInc = tauMSInc / SamplingTimeMS
        AmpFactorInc = Math.Exp(-1 / tauSampsInc)

        FreqDec = 1 / (2 * Math.PI * TimeConstDec_Sec)
        tauMSDec = 1000 / (2 * Math.PI * FreqDec)
        tauSampsDec = tauMSDec / SamplingTimeMS
        AmpFactorDec = Math.Exp(-1 / tauSampsDec)

        'LinFactorInc = Math.PI / TimeConstInc_Sec
        'LinFactorDec = Math.PI / TimeConstDec_Sec

        'LinFactorInc = 100 / tauSampsInc
        'LinFactorDec = 100 / tauSampsDec

        LinFactorInc = (1000 / SamplingTimeMS) / (TimeConstInc_Sec * 2 * Math.PI)
        LinFactorDec = (1000 / SamplingTimeMS) / (TimeConstDec_Sec * 2 * Math.PI)
    End Sub

    Friend Function Run(ByVal inValue As Double) As Double
        If LinearMode Then
            Dim diff As Double = inValue - OutValue
            If diff > 0 Then
                If diff > LinFactorInc Then
                    OutValue = OutValue + LinFactorInc
                Else
                    OutValue = inValue
                End If
            Else
                If diff < -LinFactorDec Then
                    OutValue = OutValue - LinFactorDec
                Else
                    OutValue = inValue
                End If
            End If
        Else
            If inValue > OutValue Then
                OutValue = (1 - AmpFactorInc) * inValue + AmpFactorInc * OutValue
            Else
                OutValue = (1 - AmpFactorDec) * inValue + AmpFactorDec * OutValue
            End If
        End If
        Return OutValue
    End Function

End Class
