﻿
Module Module_MeterFunctions

    Private MaxHours As Int32 = 30

    Friend StartDayPeriod As Single = 6
    Friend StartNightPeriod As Single = 22

    Private Day_hourly_impulses_for_impulsivity As Int32 = 10
    Private Night_hourly_impulses_for_impulsivity As Int32 = 2

    '------------------------------------------------------------- RED
    Friend TimeConstImpulseInc_Sec As Double = 0.001 '0.035
    Friend TimeConstImpulseDec_Sec As Double = 1.5
    ' ------------------------------------------------------------ BLUE
    Friend TimeConstFastInc_Sec As Double = 0.05 '0.035  '0.001
    Friend TimeConstFastDec_Sec As Double = 0.125
    ' ------------------------------------------------------------ GREEN
    Friend TimeConstSlowInc_Sec As Double = 0.08  '0.001
    Friend TimeConstSlowDec_Sec As Double = 1.0

    Friend FilterImpulseLinear As Boolean
    Friend FilterFastLinear As Boolean
    Friend FilterSlowLinear As Boolean


    Private PonderationA() As Double = {-50.5, -44.7, -39.4, -34.6, -30.2, -26.2, -22.5, -19.1, -16.1, -13.4, _
                                        -10.9, -8.6, -6.6, -4.8, -3.2, -1.9, -0.8, 0, 0.6, 1, _
                                        1.2, 1.3, 1.2, 1, 0.5, -0.1, -1.1, -2.5, -4.3, -6.6, _
                                        -9.3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}

    Private ThirdsOctaves() As Double = {20, 25, 31.5, 40, 50, 63, 80, 100, 125, 160, _
                                         200, 250, 315, 400, 500, 630, 800, 1000, 1250, 1600, _
                                         2000, 2500, 3150, 4000, 5000, 6300, 8000, 10000, 12500, 16000, _
                                         20000, 24000, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}

    Private DayNightString As String

    Private LoadedLines(-1) As String
    Private LoadedNumLines As Int32 = 0

    Friend RowTimeMS As Int32

    Friend Array_Raw(-1) As Double
    Friend Array_Interp(-1) As Double

    Friend Array_PondZ(-1) As Double
    Friend Array_PondC(-1) As Double
    Friend Array_PondB(-1) As Double
    Friend Array_PondA(-1) As Double
    Friend Array_BandFreq(-1) As Double

    Friend Filters_ImpulseA(-1) As Filter
    Friend Filters_FastA(-1) As Filter
    Friend Filters_SlowA(-1) As Filter
    Friend Filters_FastZ(-1) As Filter

    Friend Array_ImpulseA(-1) As Double
    Friend Array_FastA(-1) As Double
    Friend Array_SlowA(-1) As Double

    Friend Array_FastZ(-1) As Double

    Private Row_LAI As Double
    Private Row_LAF As Double
    Private Row_LAS As Double

    Private FileDate As DateTime
    Friend RowDateTime As DateTime
    Friend NumBands As Int32 = 31
    Friend MinFreq As Single
    Friend MaxFreq As Single
    Friend LogScale As Boolean
    Private TestSite As String

    Friend PeriodsCount As Int32
    Friend PeriodsCounter As Int32

    Friend ReportsInterval As Int32
    Friend LAeqInterval As Int32
    Friend PercentileInterval As Int32

    Private LAeqPartialString As String
    Private LAeqTotalString As String
    Private PercentilePartialString As String
    Private PercentileTotalString As String

    Private LAeqPartial_MinutesCounter As Int32
    Private LAeqTotal_MinutesCounter As Int32

    Private PercentilePartial_MinutesCounter As Int32
    Private PercentileTotal_MinutesCounter As Int32
    Private PercentilePartialRowCounter As Int32
    Private PercentileTotalRowCounter As Int32
    Private PercentilePartialArray(-1) As Double
    Private PercentileTotalArray(-1) As Double


    Private Sub DimAllArrays()
        ReDim Array_Raw(NumBands - 1)
        ReDim Array_Interp(NumBands - 1)

        ReDim Array_PondZ(NumBands - 1)
        ReDim Array_PondC(NumBands - 1)
        ReDim Array_PondB(NumBands - 1)
        ReDim Array_PondA(NumBands - 1)
        ReDim Array_BandFreq(NumBands - 1)

        ReDim Filters_ImpulseA(NumBands - 1)
        ReDim Filters_FastA(NumBands - 1)
        ReDim Filters_SlowA(NumBands - 1)
        ReDim Filters_FastZ(NumBands - 1)

        ReDim Array_ImpulseA(NumBands - 1)
        ReDim Array_FastA(NumBands - 1)
        ReDim Array_SlowA(NumBands - 1)
        ReDim Array_FastZ(NumBands - 1)

        For i As Int32 = 0 To NumBands - 1
            Filters_ImpulseA(i) = New Filter(RowTimeMS, TimeConstImpulseInc_Sec, TimeConstImpulseDec_Sec)
            Filters_FastA(i) = New Filter(RowTimeMS, TimeConstFastInc_Sec, TimeConstFastDec_Sec)
            Filters_SlowA(i) = New Filter(RowTimeMS, TimeConstSlowInc_Sec, TimeConstSlowDec_Sec)
            Filters_FastZ(i) = New Filter(RowTimeMS, TimeConstFastInc_Sec, TimeConstFastDec_Sec)

            Filters_ImpulseA(i).LinearMode = FilterImpulseLinear
            Filters_FastA(i).LinearMode = FilterFastLinear
            Filters_SlowA(i).LinearMode = FilterSlowLinear
            Filters_FastZ(i).LinearMode = FilterFastLinear
        Next
    End Sub

    Friend Sub MeterInitialize()
        InitAndCreateFolders()
    End Sub

    ' ===================================================================================
    '  This function creates the "Theremino_Files" folder outside the application folder
    '  The folder is created one or two levels UP, starting from the exe folder
    '  depending if the app has the sources or not
    ' -----------------------------------------------------------------------------------
    '  The final folder structure is:
    '    Theremino_AudioMeter
    '       Theremino_AudioElaboration
    '       Theremino_AudioMeter
    '       Theremino_Files
    ' -----------------------------------------------------------------------------------
    Friend DataFilePath As String
    Friend ReportsPath As String
    '
    Private Sub InitAndCreateFolders()
        Dim path As String = Application.StartupPath
        path = IO.Directory.GetParent(path).ToString
        If path.EndsWith(My.Application.Info.AssemblyName) Then
            path = IO.Directory.GetParent(path).ToString
        End If
        DataFilePath = path + "\Theremino_Files\RawData"
        IO.Directory.CreateDirectory(DataFilePath)
        ReportsPath = path + "\Theremino_Files\Reports"
        IO.Directory.CreateDirectory(ReportsPath)
    End Sub
    ' ===================================================================================

    ' ---------------------------------------------------------------------------------
    '  START PERIOD ANALISYS
    ' ---------------------------------------------------------------------------------
    Private fname As String

    Friend Sub InitFileAndScanPeriod()
        ' -----------------------------------------------------------------------------
        PrepareFileName()
        If Not ValidFileName() Then Return
        OpenInputFile()
        ScanPeriod(True)
        'CloseInputFile()
    End Sub

    Friend Sub OpenFolder()
        Process.Start(IO.Path.GetDirectoryName(fname))
    End Sub

    Friend Sub OpenTextFile()
        PrepareFileName()
        If Not ValidFileName() Then Return
        Process.Start(fname)
    End Sub


    ' ---------------------------------------------------------------------------------
    '   INPUT-FILE - PREPARE FILE-NAME / OPEN / CLOSE 
    ' ---------------------------------------------------------------------------------
    Private m_FileStream As IO.FileStream
    Private m_Streamreader As IO.StreamReader

    Private Sub PrepareFileName()
        fname = Form1.FilePathAndName
    End Sub

    Private Function ValidFileName() As Boolean
        If My.Computer.FileSystem.FileExists(fname) Then
            Return True
        Else
            Form1.TextBox_Reports.Text = vbCrLf + vbCrLf + "  FILE NOT FOUND"
            Form1.TextBox_Reports.Refresh()
            DataArray1 = Nothing
            Return False
        End If
    End Function

    Private Sub OpenInputFile()
        CloseInputFile()

        m_FileStream = IO.File.Open(fname, _
                                    IO.FileMode.Open, _
                                    IO.FileAccess.Read, _
                                    IO.FileShare.ReadWrite Or IO.FileShare.Delete)

        m_Streamreader = New IO.StreamReader(m_FileStream, _
                                             System.Text.Encoding.ASCII)
    End Sub

    Private Sub CloseInputFile()
        If m_Streamreader IsNot Nothing Then
            m_Streamreader.Close()
        End If
        If m_FileStream IsNot Nothing Then
            m_FileStream.Close()
        End If
    End Sub

    Friend Function GetFileRow(ByVal ix As Int32) As String
        If ix > LoadedNumLines - 1 Then Return ""
        Return LoadedLines(ix)
    End Function


    ' =================================================================================
    '   TEST FOR NEXT DAY
    ' =================================================================================
    Friend Sub TestForNextDay()

        ' TODO - This test loses the last second and does not works if the day is not complete
        '
        ' ------------------------------------------------------- only if 23:59:59
        If RowDateTime.Hour < 23 OrElse _
           RowDateTime.Minute < 59 OrElse _
           RowDateTime.Second < 59 Then
            Return
        End If
        ' ------------------------------------------------------- create the "tomorrow" date
        Dim tomorrow As DateTime = RowDateTime.AddDays(1)
        ' ------------------------------------------------------- test the periods counter     
        If PeriodsCounter >= PeriodsCount Then
            CloseInputFile()
            Return
        End If
        ' ------------------------------------------------------- test if the tomorrow file exists
        ' TODO ---- TOMORROW
        Dim folderName As String = IO.Path.GetDirectoryName(Form1.FilePathAndName)
        Dim fileName As String = IO.Path.GetFileName(Form1.FilePathAndName)
        Dim f As String = tomorrow.ToString("yyyy-MM-dd") + fileName.Substring(10)
        f = folderName + "\" + f
        If My.Computer.FileSystem.FileExists(f) Then
            CloseInputFile()
            fname = f
            OpenInputFile()
            ScanPeriod(False)
        End If
    End Sub


    ' =================================================================================
    '   ANALISYS
    ' =================================================================================
    Private sa() As String
    Private EnableReport As Boolean

    Private Sub ScanPeriod(ByVal ReinitArrays As Boolean)
        ' ---------------------------------------------------------- extract data from file name and first row
        sa = IO.Path.GetFileNameWithoutExtension(fname).Split("_"c)
        FileDate = ParseFileDateFromString(sa(0))
        NumBands = CInt(Val(sa(1)))
        MinFreq = CSng(Val(sa(2)))
        MaxFreq = CSng(Val(sa(3)))
        LogScale = sa(4).ToLower = "log"
        RowTimeMS = CInt(Val(sa(5)))
        TestSite = sa(6).Replace(".txt", "")
        ReadFirstRowDateTimeFromFile()
        ' ---------------------------------------------------------- reinit all
        If ReinitArrays Then ReinitAllArrays()
        ' ---------------------------------------------------------- read and analyze all file lines
        ReadAllFileLines()
        ' ---------------------------------------------------------- print final report
        EnableReport = True
        PrintPeriodicReport(ReportTypes.EndOfFastLoad)
        ' ---------------------------------------------------------- update time graph
        GraphPaper1.UpdateTimeGraph()
    End Sub


    Private Sub ReinitAllArrays()
        ' ---------------------------------------------------------- redim GraphPaper DataArray for MaxHours 
        RedimDataArrayMax((MaxHours * 3600 * 1000) \ RowTimeMS)
        DataArray1.Flush()
        DataArray1.FillWithInvalidData()
        ' ---------------------------------------------------------- initializations
        DimAllArrays()
        ResetAllCounters()
        DayNight_Init()
        Find_ImpulsiveComponents_Initialize()
        LAeqAndPercentile_Init()
        TC_Initialize()
    End Sub

    Private Sub ReadAllFileLines()
        EnableReport = False
        '
        Dim flen As Int64 = m_FileStream.Length
        If flen > 1000000 Then Form1.ProgressBar1.Show()
        Form1.Timer1.Stop()
        ReDim LoadedLines((MaxHours * 3600 * 1000) \ RowTimeMS)
        LoadedNumLines = 0
        While ScanEnabled And Not m_Streamreader.EndOfStream
            LoadedLines(LoadedNumLines) = m_Streamreader.ReadLine
            AnalyzeSingleLine(LoadedLines(LoadedNumLines))
            LoadedNumLines += 1
            If LoadedNumLines Mod 2000 = 0 Then
                Form1.ProgressBar1.Value = CInt(100 * m_FileStream.Position / m_FileStream.Length)
                Application.DoEvents()
            End If
        End While
        Form1.ProgressBar1.Hide()
        Form1.Timer1.Start()
        Form1.Refresh()
        LimitDeltaSamples()
    End Sub

    Friend ScanEnabled As Boolean

    Friend Sub ReadLastLine()
        If Not ScanEnabled Then Return
        If m_Streamreader Is Nothing Then Return
        If Not m_FileStream.CanRead Then Return
        Dim line As String = m_Streamreader.ReadLine()
        If line Is Nothing Then Return
        LoadedLines(LoadedNumLines) = line
        AnalyzeSingleLine(line)
        LoadedNumLines += 1
        GraphPaper1.UpdateTimeGraph()
        LimitDeltaSamples()
        Form1.pbox_TimeGraph.Refresh()
    End Sub


    ' ---------------------------------------------------------------------------------
    '   ANALISYZE SINGLE LINE
    ' ---------------------------------------------------------------------------------
    Private Sub AnalyzeSingleLine(ByVal line As String)
        ' -------------------------------------------------------
        If DataArray1 Is Nothing Then Return
        ' ------------------------------------------------------- split and test the element number
        sa = Split(line, vbTab)
        If sa.Length <> NumBands + 1 Then Return
        ' ------------------------------------------------------- read line elements
        For i As Int32 = 0 To NumBands - 1
            Array_Raw(i) = Val(sa(i + 1))
        Next
        ' ------------------------------------------------------- calc year day hour ... millisec from file
        RowDateTime += New TimeSpan(0, 0, 0, 0, RowTimeMS)

        ' ------------------------------------------------------- sync RowDateTime with Row HMS
        Sync_RowDateTime_WithRowHMS(sa(0))

        ' ------------------------------------------------------- test day night periods
        DayNight_Test()
        ' ------------------------------------------------------- ponderate A
        Array_PondA = AddPondA(Array_Raw)
        ' ------------------------------------------------------- filters ImpulseA
        CalcFilters(Filters_ImpulseA, Array_PondA, Array_ImpulseA)
        ' ------------------------------------------------------- filters FastA
        CalcFilters(Filters_FastA, Array_PondA, Array_FastA)
        ' ------------------------------------------------------- filters SlowA
        CalcFilters(Filters_SlowA, Array_PondA, Array_SlowA)
        ' ------------------------------------------------------- filters FastZ cioè senza ponderazione 
        CalcFilters(Filters_FastZ, Array_Raw, Array_FastZ)
        ' ------------------------------------------------------- calc the Sound Level for this row
        Row_LAI = Calc_RowSoundLevel(Array_ImpulseA)
        Row_LAF = Calc_RowSoundLevel(Array_FastA)
        Row_LAS = Calc_RowSoundLevel(Array_SlowA)
        ' ------------------------------------------------------- add row for graphics data array
        DataArray1.AddElement(Row_LAI, _
                              Row_LAF, _
                              Row_LAS, _
                              RowDateTime)
        ' ------------------------------------------------------- impulsive components
        Find_ImpulsiveComponents()
        ' ------------------------------------------------------- tonal components
        'Find_Tonal_Components(Array_PondA)
        ' ------------------------------------------------------- LAeq and Percentile integration
        LAeqAndPercentile_Integration()
        ' ------------------------------------------------------- test LAeq and percentile intervals
        TestIntervals()
        '
        ' ------------------------------------------------------- TEST - print array row
        'FilteredArrays_Print()
        '
        ' ------------------------------------------------------- test Tonal Components
        TC_CollectComponentsArray()
    End Sub


    ' ===================================================================================================
    '  READ and SYNC the ROW DATE TIME
    ' ===================================================================================================
    Private Sub ReadFirstRowDateTimeFromFile()
        m_FileStream.Position = 0
        While Not m_Streamreader.EndOfStream
            Dim s As String = m_Streamreader.ReadLine
            If s <> "" Then
                RowDateTime = FileDate
                sa = Split(s, vbTab)
                Sync_RowDateTime_WithRowHMS(sa(0))
                Exit While
            End If
        End While
        m_FileStream.Position = 0
    End Sub

    Private Sub Sync_RowDateTime_WithRowHMS(ByVal row As String)
        '
        'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        '
        ' ------------------------------------------------------------------- extract H:M:S fff from file
        If row.Length <> 12 Then Return
        Dim sa() As String = row.Split(":"c)
        If sa.Length < 3 Then Return
        Dim h As Int32 = CInt(Val(sa(0)))
        Dim m As Int32 = CInt(Val(sa(1)))
        sa = sa(2).Split(" "c)
        If sa.Length < 2 Then Return
        Dim s As Int32 = CInt(Val(sa(0)))
        Dim ms As Int32 = CInt(Val(sa(1)))
        ' -------------------------------------------------------------------- compose the DateTime
        Dim NewDateTime As DateTime = New DateTime(RowDateTime.Year, _
                                                   RowDateTime.Month, _
                                                   RowDateTime.Day, _
                                                   h, m, s, ms)
        ' -------------------------------------------------------------------- test if changed more than 1 sec
        If Math.Abs(NewDateTime.Subtract(RowDateTime).TotalSeconds) > 1 Then
            RowDateTime = NewDateTime
            'Debug.Print("Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0.0", GCI) & " uS")
        End If
    End Sub


    ' ===================================================================================================
    '  FILTERS
    ' ===================================================================================================
    Private Sub CalcFilters(ByVal filterArray() As Filter, ByVal InArray() As Double, ByRef OutArray() As Double)
        For i As Int32 = 0 To NumBands - 1
            OutArray(i) = filterArray(i).Run(InArray(i))
        Next
    End Sub


    ' ===================================================================================================
    '  LEQ and PERCENTILE
    ' ===================================================================================================
    Private LAeqPartial As Double
    Private LAeqTotal As Double

    Private L1par As Double
    Private L5par As Double
    Private L10par As Double
    Private L25par As Double
    Private L50par As Double
    Private L75par As Double
    Private L90par As Double
    Private L95par As Double
    Private L99par As Double

    Private L1tot As Double
    Private L5tot As Double
    Private L10tot As Double
    Private L25tot As Double
    Private L50tot As Double
    Private L75tot As Double
    Private L90tot As Double
    Private L95tot As Double
    Private L99tot As Double

    Private Sub LAeqAndPercentile_Init()
        LAeqPartial = 0
        LAeqTotal = 0

        L1par = 0
        L5par = 0
        L10par = 0
        L25par = 0
        L50par = 0
        L75par = 0
        L90par = 0
        L95par = 0
        L99par = 0

        L1tot = 0
        L5tot = 0
        L10tot = 0
        L25tot = 0
        L50tot = 0
        L75tot = 0
        L90tot = 0
        L95tot = 0
        L99tot = 0

        ' ----------------------------------------------------------------- dim arrays for 24 hours interval
        InitializePercentilePartialArrayFor24H()
        InitializePercentileTotalArrayFor24H()
    End Sub

    Private Sub InitializePercentilePartialArrayFor24H()
        ReDim PercentilePartialArray((MaxHours * 3600 * 1000) \ RowTimeMS)
    End Sub

    Private Sub InitializePercentileTotalArrayFor24H()
        ReDim PercentileTotalArray((MaxHours * 3600 * 1000) \ RowTimeMS)
    End Sub

    Private Sub LAeqAndPercentile_Integration()
        LAeqPartial += 10 ^ (0.1 * Row_LAF)
        ' -------------------------------------------------------
        LAeqTotal += 10 ^ (0.1 * Row_LAF)
        ' ------------------------------------------------------- 
        If PercentilePartialRowCounter < PercentilePartialArray.Length Then
            PercentilePartialArray(PercentilePartialRowCounter) = Row_LAF
        End If
        ' ------------------------------------------------------- 
        If PercentilePartialRowCounter < PercentilePartialArray.Length Then
            PercentileTotalArray(PercentileTotalRowCounter) = Row_LAF
        End If
    End Sub

    Private Sub LAeqPartial_EndPeriod()
        LAeqPartial = 10 * Math.Log10(LAeqPartial / (LAeqPartial_MinutesCounter * 60000 / RowTimeMS))
    End Sub

    Private Sub LAeqTotal_EndPeriod()
        LAeqTotal = 10 * Math.Log10(LAeqTotal / (LAeqTotal_MinutesCounter * 60000 / RowTimeMS))
    End Sub

    Private Sub PercentilePartial_EndPeriod()
        If PercentilePartialRowCounter < 100 Then Return
        ReDim Preserve PercentilePartialArray(PercentilePartialRowCounter - 1)
        Array.Sort(PercentilePartialArray)
        L1par = Lpercentile(1, PercentilePartialArray)
        L5par = Lpercentile(5, PercentilePartialArray)
        L10par = Lpercentile(10, PercentilePartialArray)
        L25par = Lpercentile(25, PercentilePartialArray)
        L50par = Lpercentile(50, PercentilePartialArray)
        L75par = Lpercentile(75, PercentilePartialArray)
        L90par = Lpercentile(90, PercentilePartialArray)
        L95par = Lpercentile(95, PercentilePartialArray)
        L99par = Lpercentile(99, PercentilePartialArray)
        InitializePercentilePartialArrayFor24H()
        PercentilePartialRowCounter = 0
    End Sub

    Private Sub PercentileTotal_EndPeriod()
        If PercentileTotalRowCounter < 100 Then Return
        ReDim Preserve PercentileTotalArray(PercentileTotalRowCounter - 1)
        Array.Sort(PercentileTotalArray)
        L1tot = Lpercentile(1, PercentileTotalArray)
        L5tot = Lpercentile(5, PercentileTotalArray)
        L10tot = Lpercentile(10, PercentileTotalArray)
        L25tot = Lpercentile(25, PercentileTotalArray)
        L50tot = Lpercentile(50, PercentileTotalArray)
        L75tot = Lpercentile(75, PercentileTotalArray)
        L90tot = Lpercentile(90, PercentileTotalArray)
        L95tot = Lpercentile(95, PercentileTotalArray)
        L99tot = Lpercentile(99, PercentileTotalArray)
        InitializePercentileTotalArrayFor24H()
        PercentileTotalRowCounter = 0
    End Sub

    Friend Function Lpercentile(ByVal n As Int32, ByVal vec() As Double) As Double
        If n > 100 Then n = 100
        n = 100 - n
        Return vec(CInt(n * vec.Length / 100))
    End Function

    Private Sub LAeqPartial_Update()
        LAeqPartialString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " LAeq = " & LAeqPartial.ToString("0.0", GCI) + vbCrLf
    End Sub

    Private Sub LAeqTotal_Update()
        LAeqTotalString += " Total" + vbCrLf
        LAeqTotalString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " LAeq = " & LAeqTotal.ToString("0.0", GCI) + vbCrLf
    End Sub

    Private Sub PercentilePartial_Update()
        PercentilePartialString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss  ") + _
                                   PercToStr(L1par) + _
                                   PercToStr(L5par) + _
                                   PercToStr(L10par) + _
                                   PercToStr(L50par) + _
                                   PercToStr(L90par) + _
                                   PercToStr(L95par) + _
                                   PercToStr(L99par) + vbCrLf
    End Sub

    Private Sub PercentileTotal_Update()
        PercentileTotalString += " Total" + vbCrLf
        PercentileTotalString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss  ") + _
                               PercToStr(L1tot) + _
                               PercToStr(L5tot) + _
                               PercToStr(L10tot) + _
                               PercToStr(L50tot) + _
                               PercToStr(L90tot) + _
                               PercToStr(L95tot) + _
                               PercToStr(L99tot) + vbCrLf
    End Sub

    Private Function PercToStr(ByVal perc As Double) As String
        If perc >= 99.5 Then
            Return perc.ToString("0  ")
        ElseIf perc >= 9.5 Then
            Return perc.ToString("0.0 ", GCI)
        Else
            Return perc.ToString(" 0.0 ", GCI)
        End If
    End Function


    Private OldDay As Int32
    Private OldMinute As Int32

    Private Sub ResetAllCounters()
        OldDay = RowDateTime.Day
        OldMinute = RowDateTime.Minute
        LAeqPartial_MinutesCounter = 0
        PercentilePartial_MinutesCounter = 0
        LAeqTotal_MinutesCounter = 0
        PercentileTotal_MinutesCounter = 0
        PercentilePartialRowCounter = 0
        PercentileTotalRowCounter = 0
        Row_LAI = 0
        Row_LAF = 0
        Row_LAS = 0
        LAeqPartialString = ""
        LAeqTotalString = ""
        PercentilePartialString = ""
        PercentileTotalString = ""
    End Sub

    Private Sub IncrementAllCounters()
        ' -------------------------------------------------- each row
        PercentilePartialRowCounter += 1
        PercentileTotalRowCounter += 1
        ' -------------------------------------------------- each minute
        If RowDateTime.Minute = OldMinute Then Return
        OldMinute = RowDateTime.Minute
        LAeqPartial_MinutesCounter += 1
        PercentilePartial_MinutesCounter += 1
        LAeqTotal_MinutesCounter += 1
        PercentileTotal_MinutesCounter += 1
    End Sub

    Private Sub TestIntervals()
        IncrementAllCounters()
        If LAeqPartial_MinutesCounter >= LAeqInterval Then
            LAeqPartial_EndPeriod()
            ' ----------------------------------------------- test if LAeg is enough ti send a mail
            Form1.TestSendMail(LAeqPartial, TestSite)
            ' -------------------------------------------------------------------------------------
            LAeqPartial_MinutesCounter = 0
            LAeqPartial_Update()
            PrintPeriodicReport(ReportTypes.LAeqInterval)
        End If
        If PercentilePartial_MinutesCounter >= PercentileInterval Then
            PercentilePartial_EndPeriod()
            PercentilePartial_MinutesCounter = 0
            PercentilePartial_Update()
            PrintPeriodicReport(ReportTypes.PercentileInterval)
        End If
    End Sub

 
    ' ===================================================================================================
    '  DAY and NIGHT functions
    ' ===================================================================================================
    Private Sub DayNight_Init()
        InitDayNightString()
        ' TODO --- REMOVE
        'If RowDateTime.Hour >= StartNightPeriod Then
        If IsTimeMoreOrEqualThen(RowDateTime, StartNightPeriod) Then
            WaitMidnight = True
        Else
            WaitMidnight = False
        End If
    End Sub

    Private WaitMidnight As Boolean
    Private Sub DayNight_Test()
        '
        ' TODO --- REMOVE
        'If DayNightString = "D" And RowDateTime.Hour >= StartNightPeriod Then
        If DayNightString = "D" And IsTimeMoreOrEqualThen(RowDateTime, StartNightPeriod) Then
            DayNightString = "N"
            WaitMidnight = True
            PercentileTotal_EndPeriod()
            PercentileTotal_Update()
            LAeqTotal_EndPeriod()
            LAeqTotal_Update()
            PrintPeriodicReport(ReportTypes.EndOfDay_H22)
            ReinitAllArrays()
            PeriodsCounter += 1
        End If
        '
        ' TODO --- REMOVE
        'If DayNightString = "N" And RowDateTime.Hour >= StartDayPeriod And Not WaitMidnight Then
        If DayNightString = "N" And IsTimeMoreOrEqualThen(RowDateTime, StartDayPeriod) And Not WaitMidnight Then
            DayNightString = "D"
            PercentileTotal_EndPeriod()
            PercentileTotal_Update()
            LAeqTotal_EndPeriod()
            LAeqTotal_Update()
            PrintPeriodicReport(ReportTypes.EndOfNight_H06)
            ReinitAllArrays()
            PeriodsCounter += 1
        End If
        '
        If RowDateTime.Day <> OldDay Then
            OldDay = RowDateTime.Day
            WaitMidnight = False
        End If
    End Sub

    Private Sub InitDayNightString()
        ' TODO --- REMOVE
        'If RowDateTime.Hour >= StartDayPeriod And RowDateTime.Hour < StartNightPeriod Then
        If IsTimeMoreOrEqualThen(RowDateTime, StartDayPeriod) And IsTimeLessThen(RowDateTime, StartNightPeriod) Then
            DayNightString = "D"
        Else
            DayNightString = "N"
        End If
    End Sub

    Private Function IsTimeMoreOrEqualThen(ByVal dt As DateTime, ByVal HourAndFraction As Single) As Boolean
        Dim t As Single = dt.Hour + dt.Minute / 60.0F
        Return t >= HourAndFraction
    End Function

    Private Function IsTimeLessThen(ByVal dt As DateTime, ByVal HourAndFraction As Single) As Boolean
        Dim t As Single = dt.Hour + dt.Minute / 60.0F
        Return t < HourAndFraction
    End Function

    Private Function DayPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartDayPeriod) + " to " + HourAndFraction_To_HoursAndMinutes(StartNightPeriod)
    End Function
    Private Function NightPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartNightPeriod) + " to " + HourAndFraction_To_HoursAndMinutes(StartDayPeriod)
    End Function
    Private Function HourAndFraction_To_HoursAndMinutes(ByVal hf As Single) As String
        Dim h As Int32 = CInt(hf)
        Dim f As Single = hf - h
        If f = 0 Then Return h.ToString
        Return h.ToString + ":" + CInt(60 * f).ToString
    End Function


    ' ===================================================================================================
    '  Search impulsive components
    ' ===================================================================================================
    Private CInight As String
    Private CIday As String
    Private Start_time As DateTime
    Private Count_impulse As Int32

    Private Sub Find_ImpulsiveComponents_Initialize()
        CInight = ""
        CIday = ""
        Start_time = RowDateTime
        Count_impulse = 0
        ImpulseStatus = ImpulseStates.WaitingMax
    End Sub

    Private Enum ImpulseStates
        WaitingMax
        WaitingEndOfPulse
    End Enum
    Private ImpulseStatus As ImpulseStates = ImpulseStates.WaitingMax
    Private FastMax_Time As DateTime
    Private FastMax_DB As Double

    Private Sub Find_ImpulsiveComponents()
        Select Case ImpulseStatus

            Case ImpulseStates.WaitingMax
                If Row_LAI - Row_LAS > 6 Then
                    ImpulseStatus = ImpulseStates.WaitingEndOfPulse
                    FastMax_DB = Row_LAF
                    FastMax_Time = RowDateTime
                End If

            Case ImpulseStates.WaitingEndOfPulse
                If FastMax_DB - Row_LAF > 10 Then
                    Dim s As String = FastMax_Time.ToString("yyyy/MM/dd HH:mm:ss +fff") + " mS  " + _
                                      FastMax_DB.ToString("0.0", GCI) + " dB" + vbCrLf
                    If DayNightString = "N" Then
                        CInight += s
                    Else
                        CIday += s
                    End If
                    ImpulseStatus = ImpulseStates.WaitingMax
                    FastMax_Time = RowDateTime
                End If
                If RowDateTime.Subtract(FastMax_Time).TotalMilliseconds > 1000 Then
                    ImpulseStatus = ImpulseStates.WaitingMax
                End If

        End Select
    End Sub

    Private Function SelectValidImpulsiveComponents(ByRef StringCI As String, ByVal NumImpulses As Int32) As String
        If StringCI = Nothing Then Return ""
        Dim sa() As String = StringCI.Split(New String() {vbCrLf}, _
                                            StringSplitOptions.RemoveEmptyEntries)
        Dim SelectedCI As String = ""
        For i As Int32 = 0 To sa.Length - 1
            Dim t1 As DateTime = ParseDateFromString(sa(i))
            ' -----------------------------------------------------------
            Dim lastImpulseIndex As Int32 = i + NumImpulses - 1
            If lastImpulseIndex >= sa.Length Then Exit For
            ' -----------------------------------------------------------
            Dim t2 As DateTime = ParseDateFromString(sa(lastImpulseIndex))
            If t2.Subtract(t1).TotalMinutes < 60 Then
                For j As Int32 = i To lastImpulseIndex
                    SelectedCI += sa(j) + vbCrLf
                Next
                SelectedCI += vbCrLf
                i = lastImpulseIndex
                If i >= sa.Length Then Exit For
            End If
        Next
        Return SelectedCI
    End Function

    Friend Sub DecodeDateAndMoveGraphPaper(ByVal nline As Int32)
        Dim d As DateTime
        If nline >= Form1.TextBox_Reports.Lines.Length Then Return
        d = ParseDateFromString(Form1.TextBox_Reports.Lines(nline))
        'Form1.Text = d.ToString
        If d <> Date.MinValue Then
            GraphPaper1.ShowTimePoint(d)
        End If
    End Sub

    Private Function ParseDateFromString(ByVal s As String) As DateTime
        Dim d As DateTime
        Dim res As Boolean
        s = s.Replace("-", "")
        s = s.Trim
        s = Strings.Left(s, 24)
        res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss +fff", Nothing, Nothing, d)
        If Not res Then
            s = Strings.Left(s, 23)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss fff", Nothing, Nothing, d)
        End If
        If Not res Then
            s = Strings.Left(s, 19)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss", Nothing, Nothing, d)
        End If
        If Not res Then
            s = Strings.Left(s, 10)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd", Nothing, Nothing, d)
        End If
        Return d
    End Function

    Private Function ParseFileDateFromString(ByVal s As String) As DateTime
        Dim d As DateTime
        DateTime.TryParseExact(s, "yyyy-MM-dd", Nothing, Nothing, d)
        Return d
    End Function

    ' ===================================================================================================
    '  REPORT BLOCKS
    ' ===================================================================================================
    Friend Enum ReportTypes
        ShortReport
        EndOfFastLoad
        LAeqInterval
        PercentileInterval
        EndOfDay_H22
        EndOfNight_H06
    End Enum


    ' TODO ------ DAY NIGHT PERIODS
    Friend Sub PrintPeriodicReport(ByVal ReportType As ReportTypes)

        Dim WriteFile As Boolean = False
        If ReportType = ReportTypes.EndOfDay_H22 Or ReportType = ReportTypes.EndOfNight_H06 Then
            WriteFile = True
        End If
        If Not EnableReport And Not WriteFile Then Return

        Form1.TextBox_Reports.Clear()
        Select Case ReportType
            Case ReportTypes.EndOfDay_H22
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of day period (" + DayPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.EndOfNight_H06
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of night period (" + NightPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.ShortReport
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " SHORT REPORT - LAST DATA LISTED EVERY " + ReportsInterval.ToString + " MINUTES" + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.EndOfFastLoad
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of FastLoad - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.LAeqInterval
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of LAeq interval - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.PercentileInterval
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of Percentile interval - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
        End Select
        ' ---------------------------------------------------------------------
        '  LAeq and PERCENTILES
        ' ---------------------------------------------------------------------
        If LAeqPartialString <> "" Or LAeqTotalString <> "" Or _
           PercentilePartialString <> "" Or PercentileTotalString <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " LAeq and Percentiles" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(LAeqPartialString)
                If PercentilePartialString <> "" Then
                    Form1.TextBox_Reports.Text += vbCrLf
                    Form1.TextBox_Reports.Text += " Percentiles          L1   L5   L10  L50  L90  L95  L99" + vbCrLf
                    Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                    Form1.TextBox_Reports.Text += GetLastRowFromString(PercentilePartialString)
                End If
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " LAeq and Percentiles" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += LAeqPartialString
                Form1.TextBox_Reports.Text += LAeqTotalString
                If PercentilePartialString <> "" Or PercentileTotalString <> "" Then
                    Form1.TextBox_Reports.Text += vbCrLf
                    Form1.TextBox_Reports.Text += " Percentiles          L1   L5   L10  L50  L90  L95  L99" + vbCrLf
                    Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                    Form1.TextBox_Reports.Text += PercentilePartialString
                    Form1.TextBox_Reports.Text += PercentileTotalString
                End If
            End If
        End If

        ' ---------------------------------------------------------------------
        '  IMPULSIVE COMPONENTS
        ' ---------------------------------------------------------------------
        Dim SelectedCI As String

        If CIday <> "" Or CInight <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulsive components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulsive components" + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulse - Slow    > 6dB                                " + vbCrLf
                Form1.TextBox_Reports.Text += " Decay to FastMax - 10dB in less than 1 seconds         " + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
            End If
        End If

        ' TODO ------ DAY NIGHT PERIODS
        If ReportType = ReportTypes.ShortReport Then
            ' ------------------------------------------------------- day
            If CIday <> "" Then
                Form1.TextBox_Reports.Text += " Day period (from " + DayPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(CIday)
            End If
            ' ------------------------------------------------------- night
            If CInight <> "" Then
                If CIday <> "" Then Form1.TextBox_Reports.Text += vbCrLf + vbCrLf
                Form1.TextBox_Reports.Text += " Night period (from " + NightPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(CInight)
            End If
        Else
            ' ------------------------------------------------------- day
            If CIday <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Day period (from " + DayPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += CIday
            End If
            SelectedCI = SelectValidImpulsiveComponents(CIday, Day_hourly_impulses_for_impulsivity)
            If SelectedCI <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Day period - Selected (at least 10 for each hour)      " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += SelectedCI
            End If
            ' ------------------------------------------------------- night
            If CInight <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Night period (from " + NightPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += CInight
            End If
            SelectedCI = SelectValidImpulsiveComponents(CInight, Night_hourly_impulses_for_impulsivity)
            If SelectedCI <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Night period - Selected (at least 2 for each hour)     " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += SelectedCI
            End If
        End If

        ' ---------------------------------------------------------------------
        '  TONAL COMPONENTS
        ' ---------------------------------------------------------------------
        If TC_ResultString <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Tonal components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastTonalComponentsFromString(TC_ResultString)
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Tonal components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += TC_ResultString
            End If
        End If

        ' ---------------------------------------------------------------------
        '  LAeq SUBTRACT OUTLIERS
        ' ---------------------------------------------------------------------
        ' TODO - ???
        'If PercentileTotalString = "" Then PercentileTotal_EndPeriod()
        ' 
        LAeq_SubtractedOutliers()
        If LAeqSubtractedOutliers_NotValidPercent > 0 And LAeqSubtractedOutliers_NotValidPercent < 1 Then
            If ReportType = ReportTypes.ShortReport Then
                '
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " OUTLIERS" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += "L'insieme dei dati campionati nel periodo sembra contenere alcuni outliers," + vbCrLf
                Form1.TextBox_Reports.Text += "riconosciuti applicando il metodo della differenza interquartile." + vbCrLf
                Form1.TextBox_Reports.Text += "L'esclusione dei dati apparentemente anomali (circa " + LAeqSubtractedOutliers_NotValidPercent.ToString("0.00000", GCI) + " %)" + vbCrLf
                Form1.TextBox_Reports.Text += "porterebbe ad un differente valore del livello continuo equivalente: " + LAeqSubtractedOutliers.ToString("0.0", GCI) + " dB(A)" + vbCrLf
            End If
        End If

        ' ---------------------------------------------------------------------
        '  UPDATE 
        ' ---------------------------------------------------------------------
        Form1.UpdateUserInterface()

        If WriteFile Then
            Form1.SaveReportText(ReportType)
        End If
    End Sub

    Private Function GetLastRowFromString(ByVal s As String) As String
        If s.Length < 3 Then Return s
        Dim n As Int32 = s.LastIndexOf(vbCrLf, s.Length - 2)
        If n < 1 Then Return s
        Return s.Substring(n + 2)
    End Function

    Private Function GetLastTonalComponentsFromString(ByVal s As String) As String
        If s.Length < 3 Then Return s
        Dim n As Int32 = s.LastIndexOf("------------------------------", s.Length - 2)
        If n < 1 Then Return s
        Return s.Substring(n + 2)
    End Function


    ' ===================================================================================================
    '  LAeq SUBTRACT OUTLIERS
    ' ===================================================================================================
    Friend LAeqSubtractedOutliers_Coefficient As Double = 3   ' (k = LAeq_SubtractOutliers)
    Private LAeqSubtractedOutliers As Double = 0
    Private LAeqSubtractedOutliers_NotValidPercent As Double

    Private Sub LAeq_SubtractedOutliers()
        If DataArray1 Is Nothing Then Return
        If DataArray1.GetNumEntries = 0 Then Return
        Dim TotalCounter As Int32 = 0
        Dim ValidCounter As Int32 = 0
        LAeqSubtractedOutliers = 0
        Dim LimitMax As Double = L25tot + LAeqSubtractedOutliers_Coefficient * (L25tot - L75tot)
        Dim LimitMin As Double = L75tot - LAeqSubtractedOutliers_Coefficient * (L25tot - L75tot)
        Dim LAF As Double
        For i As Int32 = 0 To DataArray1.GetNumEntries - 1
            ' TODO - maybe use only some time hours
            'time = DataArray1.GetElement(i).Time
            ' -------------------------------------
            LAF = DataArray1.GetElement(i).LAF
            TotalCounter += 1
            If LAF > LimitMin And LAF < LimitMax Then
                LAeqSubtractedOutliers += 10 ^ (0.1 * LAF)
                ValidCounter += 1
            End If
        Next
        If ValidCounter > 0 Then
            LAeqSubtractedOutliers = 10 * Math.Log10(LAeqSubtractedOutliers / ValidCounter)
        End If
        LAeqSubtractedOutliers_NotValidPercent = 100 - 100 * ValidCounter / TotalCounter
    End Sub

    ' ===================================================================================================
    '  TONAL COMPONENTS
    ' ===================================================================================================
    Private TC_Counter As Int32
    Private TC_StartTime As DateTime
    Private TC_StartTimeWithoutCT As DateTime = DateTime.MinValue
    Private TC_Array(-1) As Double

    Friend TC_MinTimeForStationary_Sec As Int32 = 900
    Friend TC_MaxTimeWithoutCT_Sec As Int32 = 90

    Private TC_ResultString As String

    Private Sub TC_Initialize()
        TC_ResultString = ""
        TC_Counter = 0
        TC_StartTimeWithoutCT = DateTime.MinValue
        ReDim TC_Array(NumBands - 1)
        For i As Int32 = 0 To NumBands - 1
            TC_Array(i) = 99999
        Next
    End Sub


    Private Sub TC_CollectComponentsArray()
        Dim FoundComponent As Boolean = False
        For i As Int32 = 1 To NumBands - 2
            If (Array_FastZ(i) - Array_FastZ(i + 1) > 5) And (Array_FastZ(i) - Array_FastZ(i - 1) > 5) Then 'ANDAVA USATO IL NON PONDERATO
                ' -------------------------------------------------------- init
                If TC_Counter = 0 Then
                    TC_StartTime = RowDateTime
                End If
                ' -------------------------------------------------------- add components
                For j As Int32 = 0 To NumBands - 1
                    If Array_FastZ(j) < TC_Array(j) Then TC_Array(j) = Array_FastZ(j) ' USING Z (NOT PONDERATED)
                Next
                TC_Counter += 1
                FoundComponent = True
            End If
        Next
        ' ---------------------------------------------------------------- test time without CT
        If Not FoundComponent Then
            If TC_StartTimeWithoutCT = DateTime.MinValue Then
                TC_StartTimeWithoutCT = RowDateTime
            Else
                If RowDateTime.Subtract(TC_StartTimeWithoutCT).TotalSeconds > TC_MaxTimeWithoutCT_Sec Then
                    TC_StartTimeWithoutCT = DateTime.MinValue
                    ReDim TC_Array(NumBands - 1)
                    For i As Int32 = 0 To NumBands - 1
                        TC_Array(i) = 99999
                    Next
                    TC_Counter = 0
                End If
            End If
        End If
        ' ---------------------------------------------------------------- TONAL COMPONENTS - test total time 
        If TC_Counter > 0 Then
            If RowDateTime.Subtract(TC_StartTime).TotalSeconds > TC_MinTimeForStationary_Sec Then
                TC_Counter = 0
                Find_Tonal_Components()
            End If
        End If
    End Sub


    Friend Sub Find_Tonal_Components()
        '
        Dim Lp, Ln As Double ' Lp= noise level at i-th frequency; Ln=isophonic
        Dim CT As Boolean = False
        Dim CTpenalizable As Boolean
        Dim StringCT As String
        Dim HeaderPrinted As Boolean = False
        '
        For i As Int32 = 1 To NumBands - 3
            If (TC_Array(i) - TC_Array(i + 1) > 5) And (TC_Array(i) - TC_Array(i - 1) > 5) Then
                StringCT = " CT at " & StandardFreq(i) & " Hz"
                ' --------------------------------------------------------------------------------
                ' Deriving loudness level, Ln, from frequency 
                ' (correspond to that af index i) of tonal component, CT
                ' --------------------------------------------------------------------------------
                Ln = LoudnessLevel(TC_Array(i), i)
                ' --------------------------------------------------------------------------------
                CTpenalizable = True
                For j As Int32 = 0 To NumBands - 3
                    ' ----------------------------------------------------------------------------
                    '  Deriving sound pressure level from loudness level (iso226 sect 4.1)
                    ' ----------------------------------------------------------------------------
                    Lp = PressureLevel(Ln, j)
                    ' ----------------------------------------------------------------------------
                    If j <> i And Lp < TC_Array(j) Then
                        CTpenalizable = False
                        Exit For
                    End If
                Next
                ' --------------------------------------------------------------------------------
                If Not HeaderPrinted Then
                    TC_ResultString += "------------------------------ " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                    HeaderPrinted = True
                End If
                If CTpenalizable Then
                    TC_ResultString = TC_ResultString + StringCT + " penalizable" + vbCrLf
                Else
                    TC_ResultString = TC_ResultString + StringCT + " NOT penalizable" + vbCrLf
                End If
            End If
        Next
    End Sub

End Module
