﻿
Imports System.Math

Module Module_Ponderations

    Private ThirdsOctaves() As Single = {10, 12.5, 16, 20, 25, 31.5, 40, 50, 63, 80, _
                                         100, 125, 160, 200, 250, 315, 400, 500, 630, 800, _
                                         1000, 1250, 1600, 2000, 2500, 3150, 4000, 5000, 6300, 8000, _
                                         10000, 12500, 16000, 20000, 25000, 0, 0, 0, 0, 0}

    Private PonderationA() As Single = {-70.4, -63.4, -56.7, -50.5, -44.7, -39.4, -34.6, -30.2, -26.2, -22.5, _
                                        -19.1, -16.1, -13.4, -10.9, -8.6, -6.6, -4.8, -3.2, -1.9, -0.8, _
                                          0.0, 0.6, 1.0, 1.2, 1.3, 1.2, 1.0, 0.5, -0.1, -1.1, _
                                         -2.5, -4.3, -6.6, -9.3, -12.0, 0.0, 0.0, 0.0, 0.0, 0.0}

    Private PonderationB() As Single = {-38.2, -33.2, -28.5, -24.2, -20.4, -17.1, -14.2, -11.6, -9.3, -7.4, _
                                        -5.6, -4.2, -3.0, -2.0, -1.3, -0.8, -0.5, -0.3, -0.1, 0.0, _
                                          0.0, 0.0, 0.0, -0.1, -0.2, -0.4, -0.7, -1.2, -1.9, -2.9, _
                                         -4.3, -6.1, -8.4, -11.1, -14.0, 0.0, 0.0, 0.0, 0.0, 0.0}

    Private PonderationC() As Single = {-14.3, -11.2, -8.5, -6.2, -4.4, -3.0, -2.0, -1.3, -0.8, -0.5, _
                                         -0.3, -0.2, -0.1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, _
                                          0.0, 0.0, -0.1, -0.2, -0.3, -0.5, -0.8, -1.3, -2.0, -3.0, _
                                         -4.4, -6.2, -8.5, -11.2, -14.0, 0.0, 0.0, 0.0, 0.0, 0.0}

    Private PonderationD() As Single = {-26.5, -24.5, -22.5, -20.5, -18.5, -16.5, -14.5, -12.5, -11.0, -9.0, _
                                         -7.5, -6.0, -4.5, -3.0, -2.0, -1.0, -0.5, 0.0, 0.0, 0.0, _
                                          0.0, 2.0, 5.5, 8.0, 10.0, 11.0, 11.0, 10.0, 8.5, 6.0, _
                                          3.0, 0.0, -4.0, -7.5, -12.0, 0.0, 0.0, 0.0, 0.0, 0.0}


    Private Array_BandFreq(-1) As Single

    ' ==========================================================================================
    '  USED BY METER
    ' ==========================================================================================
    Friend LevelA As Double
    Friend LevelB As Double
    Friend LevelC As Double
    Friend LevelD As Double
    Friend LevelZ As Double

    Friend Sub CalcPonderations(ByVal BandValues() As Single, _
                                ByVal mindb As Single, _
                                ByVal maxdb As Single)
        ' ----------------------------------------------------------- correct for MinDB MaxDB
        Dim bv(NumBands) As Double
        For i As Int32 = 0 To NumBands - 1
            bv(i) = mindb + BandValues(i) * (maxdb - mindb)
        Next
        ' ----------------------------------------------------------- calc ponderations
        LevelA = Calc_RowSoundLevel(AddPonderation(bv, PonderationA))
        LevelB = Calc_RowSoundLevel(AddPonderation(bv, PonderationB))
        LevelC = Calc_RowSoundLevel(AddPonderation(bv, PonderationC))
        LevelD = Calc_RowSoundLevel(AddPonderation(bv, PonderationD))
        LevelZ = Calc_RowSoundLevel(bv)

        'SmoothValue_Pow_Adaptive(LevelA, Calc_RowSoundLevel(AddPonderation(bv, PonderationA)), 5)
        'SmoothValue_Pow_Adaptive(LevelB, Calc_RowSoundLevel(AddPonderation(bv, PonderationB)), 5)
        'SmoothValue_Pow_Adaptive(LevelC, Calc_RowSoundLevel(AddPonderation(bv, PonderationC)), 5)
        'SmoothValue_Pow_Adaptive(LevelD, Calc_RowSoundLevel(AddPonderation(bv, PonderationD)), 5)
        'SmoothValue_Pow_Adaptive(LevelZ, Calc_RowSoundLevel(bv), 5)
    End Sub

    ' ==========================================================================================
    '  USED BY ELABORATION
    ' ==========================================================================================
    Friend Function AddPondA(ByVal InArray() As Double) As Double()
        Return AddPonderation(InArray, PonderationA)
    End Function

    ' ===================================================================================================
    '  ADD PONDERATION
    ' ===================================================================================================
    Private Function AddPonderation(ByVal InArray() As Double, ByVal PondArray() As Single) As Double()
        ReDim Array_BandFreq(NumBands - 1)
        ' -------------------------------------------------------------------
        Dim klog As Single = CSng((MaxFreq / MinFreq) ^ (1 / (NumBands - 1)))
        Dim klin As Single = CSng((MaxFreq - MinFreq) / (NumBands - 1))
        ' -------------------------------------------------------------------
        Dim xlog As Boolean = True
        Array_BandFreq(0) = MinFreq
        Array_BandFreq(NumBands - 1) = MaxFreq
        For i As Int32 = 1 To NumBands - 2
            If xlog Then
                Array_BandFreq(i) = Array_BandFreq(i - 1) * klog
            Else
                Array_BandFreq(i) = Array_BandFreq(i - 1) + klin
            End If
        Next
        ' -------------------------------------------------------------------- interpolated ponderation
        Dim ar(NumBands - 1) As Double
        For i As Int32 = 0 To NumBands - 1
            ar(i) = InArray(i) + Interpolate(Array_BandFreq(i), _
                                             ThirdsOctaves, _
                                             PondArray)
        Next
        '
        Return ar
    End Function

    Private Function Interpolate(ByVal x_to_interpolate As Single, ByVal X() As Single, ByVal Y() As Single) As Single
        For i As Int32 = 0 To NumBands - 2
            If x_to_interpolate <= X(i + 1) Then
                Return ((Y(i + 1) - Y(i)) * (x_to_interpolate - X(i))) / (X(i + 1) - X(i)) + Y(i)
            End If
        Next
    End Function


    ' ===================================================================================================
    '  RowSoundLevel  - integrale per riga (frequenze)
    ' ===================================================================================================
    Private RowBandsCorrection As Double = 0

    Friend Function Calc_RowSoundLevel(ByVal L() As Double) As Double
        Dim sum As Double = 0
        ' ------------------------------------------------------------- POWER 10  (-10dB -10dB)
        'For i As Int32 = 0 To NumBands - 1
        '    sum += 10 ^ (0.1 * L(i))
        'Next
        'Return 10 * Log10(sum / NumBands)
        ' ------------------------------------------------------------- POWER 10 NODIV --- OK
        For i As Int32 = 0 To NumBands - 1
            sum += 10 ^ (0.1 * L(i))
        Next
        Return 10 * Log10(sum)
        ' ------------------------------------------------------------- POWER 10 and SQRT of NumBands (-4dB -4dB)
        'For i As Int32 = 0 To NumBands - 1
        '    sum += 10 ^ (0.1 * L(i))
        'Next
        'Return 10 * Log10(sum / Sqrt(NumBands))
        ' ------------------------------------------------------------- POWER 10 and SQUARED and SQRT  (-3dB -5dB)
        'For i As Int32 = 0 To NumBands - 1
        '    sum += (10 ^ (0.1 * L(i))) ^ 2
        'Next
        'Return 10 * Log10(Sqrt(sum))
        ' ------------------------------------------------------------- SQUARED and SQRT of MID (-12dB -12dB)
        'For i As Int32 = 0 To NumBands - 1
        '    sum += L(i) * L(i)
        'Next
        'Return Sqrt(sum / NumBands)
    End Function

    'Leq sound levels are logarithmic (dB) values and cannot be added directly. 
    'A doubling of sound level results in a measured increase of 3 dB, 
    'four identical sources in a room would increase the noise level by 6 dB and so on. 
    'This works both ways, say 10 similar machines in a room produce 100 dBA 
    'then removing one machine completely will only reduce the overall noise level to 0.5 dBA, 
    'you would need to silence or remove 50% of the machines to achieve a 3 dB reduction.

End Module
