﻿Imports System.Net.Mail

Module Module_SendMail

    Friend TestOnly As Boolean
    Friend MailsCounter As Int32
    Friend RecipientsCounter As Int32

    Friend SentMailsCounter As Int32

    Friend ProgressLog As String

    Friend Sub SendMail(ByVal DestAddr As String, _
                        ByVal CcAddr As String, _
                        ByVal BccAddr As String, _
                        ByVal FromAddr As String, _
                        ByVal FromDisplayed As String, _
                        ByVal ReplyTo As String, _
                        ByVal Subject As String, _
                        ByVal AttachmentFiles As String, _
                        ByVal Body As String, _
                        ByVal IsBodyHTML As Boolean, _
                        ByVal HighPriority As Boolean, _
                        ByVal SmtpHost As String, _
                        ByVal UserName As String, _
                        ByVal Password As String, _
                        ByVal PortNoEncription As String, _
                        ByVal PortWithEncription As String, _
                        ByVal UseEncription As Boolean, _
                        ByVal AcceptInvalidCertifications As Boolean)

        Try
            ' ------------------------------------------------------------------- create mail message
            Dim mail As MailMessage = New MailMessage()
            Dim ma As MailAddress
            MailsCounter += 1
            For Each ma In DecodeAddresses(DestAddr, "To...")
                mail.To.Add(ma)
                RecipientsCounter += 1
            Next
            For Each ma In DecodeAddresses(CcAddr, "Cc...")
                mail.CC.Add(ma)
                RecipientsCounter += 1
            Next
            For Each ma In DecodeAddresses(BccAddr, "Bcc...")
                mail.Bcc.Add(ma)
                RecipientsCounter += 1
            Next
            ma = DecodeSingleAdr(FromAddr, FromDisplayed, "From")
            If ma IsNot Nothing Then mail.From = ma
            If ReplyTo IsNot Nothing AndAlso ReplyTo <> "" Then
                ma = DecodeSingleAdr(ReplyTo, "", "ReplyTo")
                If ma IsNot Nothing Then mail.ReplyTo = ma
            End If
            mail.Subject = Subject
            mail.IsBodyHtml = IsBodyHTML
            If IsBodyHTML Then
                mail.Body = Convert_CrLf_To_BR(Body)
            Else
                mail.Body = Body
            End If
            mail.Priority = MailPriority.Normal
            If AttachmentFiles IsNot Nothing Then
                AttachmentFiles = AttachmentFiles.Replace(vbCrLf, ";")
                Dim at As String() = AttachmentFiles.Split(";"c)
                For Each s As String In at
                    If s <> "" Then
                        mail.Attachments.Add(New Attachment(s))
                    End If
                Next
            End If
            ' ------------------------------------------------------------------- initialize SMTP
            Dim smtp As New SmtpClient()
            If SmtpHost <> "" Then
                smtp.Host = SmtpHost
            Else
                ProgressLog += "ERROR : Invalid SMTP Host" + vbCrLf + vbCrLf
            End If
            smtp.Credentials = New System.Net.NetworkCredential(UserName, Password)
            ' -------------------------------------------------------------------
            'smtp.UseDefaultCredentials = False ' <-- Do not use this property !!!
            ' ------------------------------------------------------------------- encription
            If UseEncription Then
                smtp.Port = CInt(Val(PortWithEncription))
                smtp.EnableSsl = True
                If AcceptInvalidCertifications Then
                    AcceptAlsoInvalidCertifications()
                End If
            Else
                smtp.Port = CInt(Val(PortNoEncription))
                smtp.EnableSsl = False
            End If
            ' -------------------------------------------------------------------- send or test-only
            If Not TestOnly Then
                ' ---------------------------------------------------------------- send async
                AddHandler smtp.SendCompleted, AddressOf SendCompleted
                Dim Token As New Object
                smtp.SendAsync(mail, Token)
                ' ---------------------------------------------------------------- send sync
                'smtp.Send(mail)
                'SentMailsCounter += 1
            End If
        Catch ex As SmtpException
            ProgressLog += "ERROR : Internet connection error" + vbCrLf + vbCrLf
        End Try
    End Sub

    Private Sub SendCompleted(ByVal sender As Object, _
                              ByVal e As System.ComponentModel.AsyncCompletedEventArgs)
        If e.Cancelled Then
            ProgressLog += "ERROR : Send mail cancelled" + vbCrLf + vbCrLf
        End If
        If e.Error IsNot Nothing Then
            ProgressLog += "ERROR : " & e.Error.Message + vbCrLf + vbCrLf
        Else
            SentMailsCounter += 1
            ProgressLog += "Mail " + SentMailsCounter.ToString + " completed" + vbCrLf
        End If
    End Sub

    Private Sub AcceptAlsoInvalidCertifications()
        System.Net.ServicePointManager.ServerCertificateValidationCallback = AddressOf AcceptAllCertifications
    End Sub

    Private Function AcceptAllCertifications(ByVal sender As Object, _
                                             ByVal certification As System.Security.Cryptography.X509Certificates.X509Certificate, _
                                             ByVal chain As System.Security.Cryptography.X509Certificates.X509Chain, _
                                             ByVal sslPolicyErrors As System.Net.Security.SslPolicyErrors) As Boolean
        Return True
    End Function

    Private Function DecodeAddresses(ByVal str As String, ByVal field As String) As MailAddress()
        Dim ma(-1) As MailAddress
        If str Is Nothing Then Return ma
        Dim sa As String() = str.Split(";"c)
        For Each s As String In sa
            s = s.Trim
            If s <> "" Then
                Try
                    Dim m As MailAddress = New MailAddress(s)
                    ReDim Preserve ma(ma.Length)
                    ma(ma.Length - 1) = m
                Catch
                    ProgressLog += "ERROR : (in field """ + field + """) " + _
                                   "The address """ + s + """ is not valid." + vbCrLf + vbCrLf
                End Try
            End If
        Next
        Return ma
    End Function

    Private Function DecodeSingleAdr(ByVal str As String, ByVal visualized As String, ByVal field As String) As MailAddress
        Try
            DecodeSingleAdr = New MailAddress(str, visualized)
        Catch
            DecodeSingleAdr = Nothing
            ProgressLog += "ERROR : (in field """ + field + """) " + _
                           "The address """ + str + """ is not valid." + vbCrLf + vbCrLf
        End Try
    End Function

    Private Function Convert_CrLf_To_BR(ByVal s As String) As String
        Return s.Replace(vbCrLf, "<br>")
    End Function

End Module
