﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion("")
        ' --------------------------------------------------------
        Combo_InitFromEnum(cmb_Spec_Window, GetType(FHT.WindowTypes))
        cmb_Spec_Window.SelectedIndex = 15
        ' -------------------------------------------------------- init panels and LoadINI
        InitPanels()
        Load_INI()
        UpdateAllPanels()
        EnableDisableWriteToFileControls()
        ' -------------------------------------------------------- Init Audio InOut Combo
        FillAudioInDevicesCombo()
        FillAudioOutDevicesCombo()
        ' -------------------------------------------------------- init controls
        SetSpectrumWindowType()
        SetSpectrumSamples()
        InitControls()
        ' -------------------------------------------------------- timings
        SchedulerMaxPrecision()
        Timer1.Interval = 20
        ' -------------------------------------------------------- init AudioMeter and SpectrumBands
        AudioMeter.Initialize(SelectedAudioIn, GetNsamples)
        OpenCloseSubsystems()
        UpdateAll()
        ' -------------------------------------------------------- init calibrations
        SetFrequencyFromSelectedBand()
        InitAudioOut
        ' -------------------------------------------------------- start
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ReduceVolumeAndStop()
        AudioMeter.CloseAll()
        SpectrumBands.CloseAll()
        Spectrum.CloseAll()
        SchedulerDefaultPrecision()
        Save_INI()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        SplitContainer1.Width = Me.ClientSize.Width - SplitContainer1.Left - 6
        SplitContainer1.Height = Me.ClientSize.Height - SplitContainer1.Top - 6
        OpenCloseSubsystems()
        UpdateAll()
    End Sub

    Private Sub GroupBox_Bands_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_Bands.Click
        SplitContainer1.SplitterDistance = 9999
    End Sub

    Private Sub GroupBox_Spectrum_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_Spectrum.Click
        SplitContainer1.SplitterDistance = 0
    End Sub

    Private Sub OpenCloseSubsystems()
        If Me.Height > 100 Then
            Spectrum.Initialize(pbox_Spectrum, SelectedAudioIn, GetNsamples)
            SpectrumBands.Initialize(pbox_SpectrumBars, SelectedAudioIn, GetNsamples)
            Timer1.Start()
        Else
            SpectrumBands.CloseAll()
            Spectrum.CloseAll()
            Timer1.Stop()
        End If
    End Sub

    Friend Sub ReduceVolumeAndStop()
        ' ----------------------------------------------------------------- reduce smoothly the volume
        wp1.PlayPrepareForStop()
        ' ----------------------------------------------------------------- wait to avoid closing noise
        Dim waittime As Int32 = 0
        waittime = Math.Max(waittime, wp1.GetTotalDelayMillisec)
        Threading.Thread.Sleep(waittime + 10)
        ' ----------------------------------------------------------------- and close
        wp1.PlayStopImmediate()
    End Sub

    ' Removed (because generates 2 seconds of zero at the start of the file)
    'Private Sub chk_WriteToFile_ClickButtonArea_1(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles chk_WriteToFile.ClickButtonArea
    '    If chk_WriteToFile.Checked Then
    '        AudioMeter.Initialize(SelectedAudioIn)
    '    Else
    '        AudioMeter.CloseAll()
    '    End If
    'End Sub

    Private Sub chk_WriteToFile_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles chk_WriteToFile.ClickButtonArea
        If chk_WriteToFile.Checked Then
            AudioMeter.CloseAndReopenFile()
        End If
        EnableDisableWriteToFileControls()
    End Sub

    Private Sub EnableDisableWriteToFileControls()
        Dim enable As Boolean = Not chk_WriteToFile.Checked
        txt_BandsCount.Enabled = enable
        txt_SpecMaxFreq.Enabled = enable
        txt_SpecMinFreq.Enabled = enable
        chk_SpecLog.Enabled = enable
        txt_Site.Enabled = enable
        txt_Site.BackColor = If(enable, Color.MintCream, Color.LightGray)
    End Sub

    Private Sub btn_DeleteFile_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteFile.ClickButtonArea
        WriteToFile = False
        chk_WriteToFile.Checked = False
        EnableDisableWriteToFileControls()
        AudioMeter.DeleteOutputFile()
    End Sub

    Private Sub btn_OpenFilesFolder_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenFilesFolder.ClickButtonArea
        AudioMeter.OpenOutFolder()
    End Sub

    Private Sub SplitContainer1_SplitterMoved(ByVal sender As Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved
        If Not EventsAreEnabled Then Return
        Spectrum.Initialize(pbox_Spectrum, SelectedAudioIn, GetNsamples)
        SpectrumBands.Initialize(pbox_SpectrumBars, SelectedAudioIn, GetNsamples)
        GroupBox4.Select()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        UpdateAll()
    End Sub

    Private SpectrumWindowType As FHT.WindowTypes
    Private Sub UpdateAll()
        If Not Me.Visible Then Return
        ReportString = ""
        ' ----------------------------------------------------- 
        SpectrumBands.Update(pbox_SpectrumBars, _
                             Speed, _
                             SpectrumWindowType)
        ' ----------------------------------------------------- 
        Spectrum.Update(pbox_Spectrum, _
                        Speed, _
                        SpectrumWindowType)

        AudioMeter.WindowType = SpectrumWindowType
        ' -----------------------------------------------------
        If ReportString <> "" Then Text = ReportString
        ' ----------------------------------------------------- print ponderated levels
        txt_LevelA.Text = LevelA.ToString("0.0", GCI)
        txt_LevelB.Text = LevelB.ToString("0.0", GCI)
        txt_LevelC.Text = LevelC.ToString("0.0", GCI)
        txt_LevelD.Text = LevelD.ToString("0.0", GCI)
        txt_LevelZ.Text = LevelZ.ToString("0.0", GCI)
        ' ----------------------------------------------------- overload indicator
        If LevelA > MaxdB Then
            If Not SignalOverload Then
                SignalOverload = True
                GroupBox_Bands.BackColor = Color.Red
                GroupBox_Spectrum.BackColor = Color.Red
            End If
        Else
            If SignalOverload Then
                SignalOverload = False
                GroupBox_Bands.BackColor = GroupBox1.BackColor
                GroupBox_Spectrum.BackColor = GroupBox1.BackColor
            End If
        End If
    End Sub

    ' ===================================================================================================
    '  SELECT AUDIO INPUT 
    ' ===================================================================================================
    Friend SelectedAudioIn As Int32 = 0
    Private Sub cmb_AudioInDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDown
        cmb_AudioInDevices.ItemHeight = 16
        FillAudioInDevicesCombo()
    End Sub
    Private Sub cmb_AudioInDevices_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDownClosed
        cmb_AudioInDevices.ItemHeight = 11
        ' ------------------------------------------------------------ only when closing combo
        SelectedAudioIn = cmb_AudioInDevices.SelectedIndex
        AudioMeter.Initialize(SelectedAudioIn, GetNsamples)
        Spectrum.Initialize(pbox_Spectrum, SelectedAudioIn, GetNsamples)
        SpectrumBands.Initialize(pbox_SpectrumBars, SelectedAudioIn, GetNsamples)
    End Sub
    Private Sub FillAudioInDevicesCombo()
        Dim sa As String() = WaveNative.GetInputDevicesNames
        If sa.Length = 0 Then ReDim sa(0)
        cmb_AudioInDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioInDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioInDevices, SelectedAudioIn)
    End Sub

    ' ===================================================================================================
    '  SELECT AUDIO OUTPUT 
    ' ===================================================================================================
    Friend SelectedAudioOut As Int32 = 0
    Private Sub cmb_AudioOutDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDown
        cmb_AudioOutDevices.ItemHeight = 16
        FillAudioOutDevicesCombo()
    End Sub
    Private Sub cmb_AudioOutDevices_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDownClosed
        cmb_AudioOutDevices.ItemHeight = 11
    End Sub
    Private Sub ccmb_AudioOutDevices_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.SelectedIndexChanged
        If Not EventsAreEnabled Then Return
        SelectedAudioOut = cmb_AudioOutDevices.SelectedIndex
        If chk_CalibEnableOut.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        End If
    End Sub
    Private Sub FillAudioOutDevicesCombo()
        Dim sa As String() = WaveNative.GetOutputDevicesNames
        If sa.Length = 0 Then ReDim sa(0) : sa(0) = ""
        cmb_AudioOutDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioOutDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioOutDevices, SelectedAudioOut)
    End Sub

    ' ===================================================================================================
    '  AUDIO IN OUT HELPERS
    ' ===================================================================================================
    Private Sub btn_AudioInputs_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioInputs.ClickButtonArea
        Open_AudioInputs()
    End Sub
    Private Sub btn_AudioMixer_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioMixer.ClickButtonArea
        Open_AudioMixer()
    End Sub
    Private Sub btn_AudioOutputs_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioOutputs.ClickButtonArea
        Open_AudioOutputs()
    End Sub
    Private Function ExtractDeviceName(ByVal s As String) As String
        If s = Nothing Then Return ""
        Dim i As Int32 = InStr(s, "(") - 1
        Dim s2 As String = ""
        If i > 1 Then s2 = s.Remove(i)
        s2 = s2.Trim
        If s.ToLower.Contains("usb") Then s2 = s2 + " USB"
        Return s2
    End Function


    ' ===================================================================================================
    '  COMBO 
    ' ===================================================================================================
    Private Sub AllCombo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
                                                                                cmb_Spec_Window.DropDown, _
                                                                                cmb_Samples.DropDown
        CType(sender, ComboBox).ItemHeight = 16
        CType(sender, ComboBox).DropDownWidth = 1
    End Sub

    Private Sub AllCombo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
                                                                            cmb_Spec_Window.DropDownClosed, _
                                                                            cmb_Samples.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub

    Private Sub cmb_Spec_Window_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles cmb_Spec_Window.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetSpectrumWindowType()
        GroupBox4.Focus()
    End Sub
    Private Sub SetSpectrumWindowType()
        SpectrumWindowType = CType(cmb_Spec_Window.SelectedIndex, FHT.WindowTypes)
    End Sub

    Private Sub cmb_Samples_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                Handles cmb_Samples.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetSpectrumSamples()
        GroupBox4.Focus()
    End Sub
    Private Sub SetSpectrumSamples()
        AudioMeter.Initialize(SelectedAudioIn, GetNsamples)
        Spectrum.Initialize(pbox_Spectrum, SelectedAudioIn, GetNsamples)
        SpectrumBands.Initialize(pbox_SpectrumBars, SelectedAudioIn, GetNsamples)
    End Sub

    Private Function GetNsamples() As Int32
        Dim nsamples As Int32 = CInt(Val(cmb_Samples.Text))
        If nsamples = 0 Then
            nsamples = 8192
            cmb_Samples.Text = "8192"
        End If
        Return nsamples
    End Function


    ' ===================================================================================================
    '  USER PARAMS 
    ' ===================================================================================================

    Private Sub SaveParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                Handles txt_Calibration.LostFocus, _
                                                                        chk_RoundDisplayFreq.LostFocus, _
                                                                        txt_BandsCount.LostFocus, _
                                                                        txt_SpecMaxDb.LostFocus, _
                                                                        txt_SpecMinDb.LostFocus, _
                                                                        txt_SpecMaxFreq.LostFocus, _
                                                                        txt_SpecMinFreq.LostFocus, _
                                                                        txt_SpecSpeed.LostFocus, _
                                                                        chk_SpecLog.LostFocus, _
                                                                        cmb_Spec_Window.LostFocus, _
                                                                        txt_FirstSlot.LostFocus, _
                                                                        txt_Site.LostFocus, _
                                                                        chk_WriteToFile.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub Controls_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_Calibration.TextChanged, _
                                                                            chk_RoundDisplayFreq.CheckedChanged, _
                                                                            txt_SpecMaxDb.TextChanged, _
                                                                            txt_SpecMinDb.TextChanged, _
                                                                            txt_SpecMaxFreq.TextChanged, _
                                                                            txt_SpecMinFreq.TextChanged, _
                                                                            txt_SpecSpeed.TextChanged, _
                                                                            chk_SpecLog.CheckedChanged, _
                                                                            txt_FirstSlot.TextChanged, _
                                                                            txt_Site.TextChanged, _
                                                                            chk_WriteToFile.CheckedChanged
        If Not EventsAreEnabled Then Return
        InitControls()
    End Sub

    Private Sub txt_BandsCount_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_BandsCount.TextChanged
        If Not EventsAreEnabled Then Return
        InitControls()
        Select Case NumBands
            Case 10
                MinFreq = 22.4
                MaxFreq = 22400
            Case 31
                MinFreq = 17.8
                MaxFreq = 22400
        End Select
        EventsAreEnabled = False
        txt_SpecMinFreq.NumericValue = MinFreq
        txt_SpecMaxFreq.NumericValue = MaxFreq
        EventsAreEnabled = True
    End Sub

    Private Sub InitControls()
        Calibration = CSng(Val(txt_Calibration.Text)) + ZeroCalibration
        RoundDisplayFreq = chk_RoundDisplayFreq.Checked
        NumBands = txt_BandsCount.NumericValueInteger()
        MinFreq = CSng(txt_SpecMinFreq.NumericValue)
        MaxFreq = CSng(txt_SpecMaxFreq.NumericValue)
        MindB = CSng(txt_SpecMinDb.NumericValue)
        MaxdB = CSng(txt_SpecMaxDb.NumericValue)
        LogX = chk_SpecLog.Checked
        Speed = txt_SpecSpeed.NumericValueInteger / 100.0F
        TestSite = txt_Site.Text.Replace(" ", "")
        FirstSlot = CInt(Val(txt_FirstSlot.Text))
        WriteToFile = chk_WriteToFile.Checked
        ' ----------------------------------------------------------
        If chk_SpecLog.Checked Then
            chk_SpecLog.Text = "Logarithmic"
        Else
            chk_SpecLog.Text = "Linear"
        End If
        ' ----------------------------------------------------------
        If MinFreq < 1 Then MinFreq = 1
        If MindB < 0 Then MindB = 0
    End Sub



    ' ===================================================================================================
    '  PANELS 
    ' ===================================================================================================
    Private PanelHeight(6) As Int32

    Private Sub InitPanels()
        PanelHeight(1) = GroupBox1.Height
        PanelHeight(2) = GroupBox2.Height
        PanelHeight(3) = GroupBox3.Height
        PanelHeight(4) = GroupBox4.Height
        PanelHeight(5) = GroupBox5.Height
        PanelHeight(6) = GroupBox6.Height
    End Sub

    Private Sub GroupBox_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox1.Click, _
                                                                                            GroupBox2.Click, _
                                                                                            GroupBox3.Click, _
                                                                                            GroupBox4.Click, _
                                                                                            GroupBox5.Click, _
                                                                                            GroupBox6.Click
        Dim gbox As GroupBox = CType(sender, GroupBox)
        If gbox.PointToClient(MousePosition).Y > 20 Then Return
        ToggleGboxHeight(gbox)
        UpdateAllPanels()
    End Sub

    Private Sub ToggleGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height > 20 Then
            gbox.Height = 16
        Else
            If Not TestPassword(i) Then Return
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub SetGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height <= 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub UpdateAllPanels()
        ' --------------------------------------- Use this method if some GBOX is not located on the form
        GroupBox4.Parent = Me
        GroupBox5.Parent = Me
        GroupBox6.Parent = Me
        GroupBox4.Left = GroupBox1.Left
        GroupBox5.Left = GroupBox1.Left
        GroupBox6.Left = GroupBox1.Left
        ' --------------------------------------- Ensure the correct height also if INI is not ok
        SetGboxHeight(GroupBox1)
        SetGboxHeight(GroupBox2)
        SetGboxHeight(GroupBox3)
        SetGboxHeight(GroupBox4)
        SetGboxHeight(GroupBox5)
        SetGboxHeight(GroupBox6)
        ' --------------------------------------- Set the vertical positions
        GroupBox2.Top = GroupBox1.Bottom + 5
        GroupBox3.Top = GroupBox2.Bottom + 5
        GroupBox4.Top = GroupBox3.Bottom + 5
        GroupBox5.Top = GroupBox4.Bottom + 5
        GroupBox6.Top = GroupBox5.Bottom + 5
        ' ------------------------------------------------------------- update form MinimumSize
        Dim topSize As Int32 = Me.Size.Height - Me.ClientSize.Height
        Dim MinHeight As Int32 = GroupBox6.Bottom + topSize + 6
        If MinHeight < 480 Then MinHeight = 480
        Me.MinimumSize = New Size(Me.MinimumSize.Width, MinHeight)
        ' ------------------------------------------------------------- update CalibPanelOpened
        CalibPanelOpened = GroupBox2.Height > 20
    End Sub

    ' ====================================================================================================
    '  PASSWORD
    ' ====================================================================================================
    Private PDB As PasswordDialogBox = New PasswordDialogBox()
    Private Function TestPassword(ByVal n As Int32) As Boolean
        If Not ReadIdentifiersFile() Then Return False
        If PDB.Password = RequestedPassword Then Return True
        If n = 1 Or n = 5 Or n = 6 Then Return True
        PDB.OpenDialog(Me)
    End Function

    Private RequestedPassword As String = "#####################"
    Friend Function ReadIdentifiersFile() As Boolean
        Dim FileLines(-1) As String
        Dim fname As String
        fname = Application.StartupPath + "\..\Theremino_Files\Identifiers\Identifiers.txt"
        If Not My.Computer.FileSystem.FileExists(fname) Then
            fname = Application.StartupPath + "\..\..\Theremino_Files\Identifiers\Identifiers.txt"
        End If
        If My.Computer.FileSystem.FileExists(fname) Then
            FileLines = IO.File.ReadAllLines(fname)
            For j As Int32 = 0 To FileLines.Length - 1
                Dim sa() As String = FileLines(j).Trim.Split("="c)
                If sa.Length = 2 Then
                    Select Case sa(0).ToLower
                        Case "metertrimming" : RequestedPassword = sa(1)
                    End Select
                End If
            Next
            Return True
        Else
            MessageBox.Show("Can not find the file: ""...Theremino_Files\Identifiers\Identifiers.txt""", _
                            "Message from AudioMeter")
            Return False
        End If
    End Function


    ' ====================================================================================================
    '  FrequencyGraph SelectBand and TestBand
    ' ====================================================================================================
    Private Sub pbox_SpectrumBars_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_SpectrumBars.MouseDown
        SelectBand(e.X)
    End Sub
    Private Sub pbox_SpectrumBars_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_SpectrumBars.MouseMove
        If e.Button = Windows.Forms.MouseButtons.None Then Return
        SelectBand(e.X)
    End Sub
    Private Sub SelectBand(ByVal x As Single)
        If pbox_SpectrumBars.Image Is Nothing Then Return
        Dim wpix As Int32 = pbox_SpectrumBars.Image.Width - 1
        Dim rowsize As Single = CSng(wpix / NumBands)
        Dim b As Int32 = CInt(Math.Floor(x / rowsize))
        CalibSelectedBand = b
        SetFrequencyFromSelectedBand()
        InitAudioOut()
    End Sub
    Private Sub SetFrequencyFromSelectedBand()
        If CalibSelectedBand < 0 Then CalibSelectedBand = 0
        If CalibSelectedBand > NumBands - 1 Then CalibSelectedBand = NumBands - 1
        txt_CalibFrequency.NumericValue = SpectrumBands.GetRoundedFreq(CalibSelectedBand)
        InitTextBoxes_FromCalibrationArrays()
        txt_CalibOut.Enabled = True
        txt_CalibMic.Enabled = True
    End Sub
    Private Sub InitTextBoxes_FromCalibrationArrays()
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        txt_CalibOut.NumericValue = GetGeneratorCalibrationValue(NumBands, CalibSelectedBand)
        txt_CalibMic.NumericValue = GetMicCalibrationValue(NumBands, CalibSelectedBand)
        EventsAreEnabled = old
    End Sub
    Private Sub txt_CalibFrequency_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_CalibFrequency.TextChanged
        If Not EventsAreEnabled Then Return
        wp1.SetFrequency(txt_CalibFrequency.NumericValueInteger)
        txt_CalibOut.Enabled = False
        txt_CalibMic.Enabled = False
    End Sub

    Private Sub txt_CalibOut_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_CalibOut.TextChanged
        If Not EventsAreEnabled Then Return
        InitCalibrationArrays_FromTextBoxes()
        InitAudioOut()
    End Sub
    Private Sub txt_CalibMic_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_CalibMic.TextChanged
        If Not EventsAreEnabled Then Return
        InitCalibrationArrays_FromTextBoxes()
    End Sub
    Private Sub InitCalibrationArrays_FromTextBoxes()
        SetGeneratorCalibrationValue(NumBands, CalibSelectedBand, CSng(txt_CalibOut.NumericValue))
        SetMicCalibrationValue(NumBands, CalibSelectedBand, CSng(txt_CalibMic.NumericValue))
    End Sub

    Private Sub SaveCalibArraysOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                           Handles txt_CalibOut.MouseLeave, _
                                                                                   txt_CalibMic.MouseLeave
        If Not EventsAreEnabled Then Return
        Save_INI()
        pbox_SpectrumBars.Focus()
    End Sub

    Private Sub btn_Interpolate_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Interpolate.ClickButtonArea
       Select NumBands
            Case 31
                If MessageBox.Show("Ready to interpolate calibrations from 10 bands to 31 bands." + vbCrLf + vbCrLf + _
                            "Do you wont to proceed ?", _
                            "Calibrations interpolator", _
                            MessageBoxButtons.YesNo, _
                            MessageBoxIcon.Question, _
                            MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
                    InterpolateCalibrations("10 to 31")
                End If
            Case 10
                If MessageBox.Show("Ready to interpolate calibrations from 31 bands to 10 bands." + vbCrLf + vbCrLf + _
                            "Do you wont to proceed ?", _
                            "Calibrations interpolator", _
                            MessageBoxButtons.YesNo, _
                            MessageBoxIcon.Question, _
                            MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
                    InterpolateCalibrations("31 to 10")
                End If
            Case Else
                MessageBox.Show("Calibrations are implemented for 10 bands and 31 bands only.", _
                                "Calibrations interpolator")
        End Select
        btn_Interpolate.Checked = False
    End Sub


    ' ===================================================================================================
    '  AUDIO OUT 
    ' ===================================================================================================
    Private Sub OudioOutControls_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_CalibOutputDB.LostFocus, _
                                                                            chk_CalibEnableOut.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub
    Private Sub OudioOutControls_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                        Handles txt_CalibOutputDB.TextChanged, _
                                                                                chk_CalibEnableOut.CheckedChanged
        If Not EventsAreEnabled Then Return
        InitAudioOut()
    End Sub

    Private wp1 As WavePlayer = New WavePlayer

    Private Sub InitAudioOut()
        wp1.SetFrequency(txt_CalibFrequency.NumericValueInteger)
        wp1.SetOutLevel(CSng(txt_CalibOutputDB.NumericValue + txt_CalibOut.NumericValue) - 150)
        wp1.SetPan(0)
        wp1.SetWaveType(WavePlayer.WaveTypes.Sine)
        If chk_CalibEnableOut.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            ReduceVolumeAndStop()
        End If
    End Sub

End Class
