Module Module_Utils

    Public ReportString As String

    ' ===================================================================================================
    '  UTILS
    ' ===================================================================================================
    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
		 If .ClientSize.Height < 1 Then Return
            If .Image Is Nothing OrElse .Image.Width <> .ClientSize.Width OrElse .Image.Height <> .ClientSize.Height Then
                .Image = New Bitmap(.ClientRectangle.Width, .ClientRectangle.Height, Imaging.PixelFormat.Format24bppRgb)
            End If
        End With
    End Sub

    ' ----------------------------------------------------------------------------
    '  COMBO
    ' ----------------------------------------------------------------------------
    Friend Sub Combo_InitFromEnum(ByVal combo As ComboBox, ByVal enumType As Type) ' use GeType(enum)
        For Each s As String In [Enum].GetNames(enumType)
            combo.Items.Add(s)
        Next
    End Sub
    Friend Sub Combo_SetIndex(ByVal combo As ComboBox, ByRef index As Int32)
        Dim n As Int32 = combo.Items.Count
        If n = 0 Then Return
        If index < 0 Then index = 0
        If index > n - 1 Then index = n - 1
        combo.SelectedIndex = index
    End Sub

    ' =======================================================================================================
    '   CULTURE INFO FOR STRING CONVERSIONS
    ' =======================================================================================================
    Friend GCI As Globalization.CultureInfo = Globalization.CultureInfo.InvariantCulture

    ' ----------------------------------------------------------------------------
    '  OPEN AUDIO CONTROLS
    ' ----------------------------------------------------------------------------
    Friend Sub Open_AudioOutputs()
        Shell("control mmsys.cpl,,0", AppWinStyle.NormalFocus)
    End Sub
    Friend Sub Open_AudioInputs()
        Shell("control mmsys.cpl,,1", AppWinStyle.NormalFocus)
    End Sub
    Friend Sub Open_AudioMixer()
        Dim mixerpath As String
        mixerpath = "C:\WINDOWS\system32\sndvol32.exe"
        If Not My.Computer.FileSystem.FileExists(mixerpath) Then
            mixerpath = "C:\WINDOWS\system32\sndvol.exe"
        End If
        If My.Computer.FileSystem.FileExists(mixerpath) Then
            Shell(mixerpath, AppWinStyle.NormalFocus)
        End If
        'Shell("C:\WINDOWS\system32\sndvol32.exe /rec", AppWinStyle.NormalFocus)
        'Shell("C:\WINDOWS\system32\sndvol.exe /rec", AppWinStyle.NormalFocus)
    End Sub


    ' =========================================================================
    '  WINDOWS SCHEDULER PRECISION
    ' ========================================================================= 
    Private Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Private Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Int32) As Int32
    Friend Sub SchedulerMaxPrecision()
        If OperatingSystemIsWindows Then
            timeBeginPeriod(1)
        End If
    End Sub
    Friend Sub SchedulerDefaultPrecision()
        If OperatingSystemIsWindows Then
            timeEndPeriod(1)
        End If
    End Sub


    ' =============================================================
    '    New Adaptive - Working OK
    ' =============================================================
    Friend Sub SmoothValue_Pow_Adaptive(ByRef value As Double, ByVal new_value As Double, ByVal speed As Double)
        Dim delta As Double = new_value - value
        Dim delta_sgn As Double = Math.Sign(delta)
        Dim delta_abs As Double = Math.Abs(delta)
        Dim delta_pow As Double = CSng(delta_abs ^ 2) * speed
        If value <> 0 Then delta_pow /= Math.Abs(value)
        If delta_pow >= delta_abs Then
            value = new_value
        Else
            value += delta_sgn * delta_pow
        End If
        ' ------------------ if not equal to itself then it is a NAN
        If value <> value Then value = 0
    End Sub

End Module
